//------------------------------------------------------------------
#property copyright "www.forex-tsd.com" 
#property link      "www.forex-tsd.com" 
//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1  Red
#property indicator_color2  LimeGreen
#property indicator_color3  Red
#property indicator_color4  LimeGreen
#property indicator_color5  Red
#property indicator_color6  LimeGreen
#property indicator_color7  PaleVioletRed
#property indicator_color8  DeepSkyBlue
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_width7  1
#property indicator_width8  1

//
//
//
//
//

extern int    MaPeriod         = 10;
extern int    MaMetod          = 2;
extern int    Step             = 1;
extern bool   BetterFormula    = false;
extern bool   T3Average        = true;
extern double T3Hot            = 1.0;
extern bool   T3Original       = false;
extern bool   ShowArrows       = true;

extern string _                = "Alerts settings";
extern bool   Alerts.On        = true;
extern bool   Alerts.OnCurrent = false;
extern bool   Alerts.Message   = true;
extern bool   Alerts.Sound     = true;
extern bool   Alerts.Email     = false;

//
//
//
//
//

double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];
double Buffer5[];
double Buffer6[];
double UpArrow[];
double DnArrow[];

//+------------------------------------------------------------------+
//|                                                                  |
//|------------------------------------------------------------------|
//
//
//
//
//

int init()
{
   SetIndexBuffer(0, Buffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1, Buffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2, Buffer3); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3, Buffer4); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4, Buffer5); 
   SetIndexBuffer(5, Buffer6); 
   SetIndexBuffer(6, DnArrow);
   SetIndexBuffer(7, UpArrow); 
   if (ShowArrows)
   {
   SetIndexStyle(6,DRAW_ARROW); SetIndexArrow(6,234);
   SetIndexStyle(7,DRAW_ARROW); SetIndexArrow(7,233);
   }
   else
   {
   SetIndexStyle(6,DRAW_NONE);
   SetIndexStyle(7,DRAW_NONE);
   }

   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int    counted_bars=IndicatorCounted();
   int    pointModifier;
   int    limit;

   //
   //
   //
   //
   //
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMin(Bars-counted_bars,Bars-1);
     
         if (Digits==3 || Digits==5)
               pointModifier = 10;
         else  pointModifier = 1;               
          
   //
   //
   //
   //
   //
   
   for (int pos=limit; pos >= 0; pos--)
   {
      if (T3Average)
         {
            double maOpen  = iT3(Open[pos], MaPeriod,T3Hot,T3Original,pos, 0);
            double maClose = iT3(Close[pos],MaPeriod,T3Hot,T3Original,pos, 1);
            double maLow   = iT3(Low[pos],  MaPeriod,T3Hot,T3Original,pos, 2);
            double maHigh  = iT3(High[pos], MaPeriod,T3Hot,T3Original,pos, 3);
            Buffer5[pos]   = iT3(iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW,   pos),MaPeriod,T3Hot,T3Original,pos,4);
            Buffer6[pos]   = iT3(iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH,  pos),MaPeriod,T3Hot,T3Original,pos,5);
            
         }
      else
         {
            maOpen        = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_OPEN, pos);
            maClose       = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_CLOSE,pos);
            maLow         = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_LOW,  pos);
            maHigh        = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_HIGH, pos);
            Buffer5[pos]  = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_LOW,  pos);
            Buffer6[pos]  = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_HIGH, pos);
         }
   
      //
      //
      //
      //
      //
        
         if (BetterFormula) {
               if (maHigh != maLow)
                     double haClose = (maOpen+maClose)/2+(((maClose-maOpen)/(maHigh-maLow))*MathAbs((maClose-maOpen)/2));
               else  haClose        = (maOpen+maClose)/2; }
         else        haClose        = (maOpen+maHigh+maLow+maClose)/4;
                     double haOpen  = (Buffer3[pos+1]+Buffer4[pos+1])/2;
                     double haHigh  = MathMax(maHigh, MathMax(haOpen,haClose));
                     double haLow   = MathMin(maLow,  MathMin(haOpen,haClose));

         if (haOpen<haClose) { Buffer1[pos]=haLow;  Buffer2[pos]=haHigh; } 
         else                { Buffer1[pos]=haHigh; Buffer2[pos]=haLow;  } 
                               Buffer3[pos]=haOpen;
                               Buffer4[pos]=haClose;
      
      //
      //
      //
      //
      //

      if (Step>0)
      {
         if (MathAbs(Buffer1[pos]-Buffer1[pos+1]) < Step*pointModifier*Point) Buffer1[pos]=Buffer1[pos+1];
         if (MathAbs(Buffer2[pos]-Buffer2[pos+1]) < Step*pointModifier*Point) Buffer2[pos]=Buffer2[pos+1];
         if (MathAbs(Buffer3[pos]-Buffer3[pos+1]) < Step*pointModifier*Point) Buffer3[pos]=Buffer3[pos+1];
         if (MathAbs(Buffer4[pos]-Buffer4[pos+1]) < Step*pointModifier*Point) Buffer4[pos]=Buffer4[pos+1];
         if (MathAbs(Buffer5[pos]-Buffer5[pos+1]) < Step*pointModifier*Point) Buffer5[pos]=Buffer5[pos+1];
         if (MathAbs(Buffer6[pos]-Buffer6[pos+1]) < Step*pointModifier*Point) Buffer6[pos]=Buffer6[pos+1];
      }        
       
      UpArrow[pos]=EMPTY_VALUE;
      DnArrow[pos]=EMPTY_VALUE;
        
      if (Buffer3[pos] < Buffer4[pos] && Buffer4[pos+1] < Buffer3[pos+1]) UpArrow[pos] = Buffer6[pos+1]-(Ask-Bid);
      if (Buffer3[pos] > Buffer4[pos] && Buffer4[pos+1] > Buffer3[pos+1]) DnArrow[pos] = Buffer5[pos+1]+(Ask-Bid);
   }
    
   //
   //
   //
   //
   //
         
   if (Alerts.On)
   {
      if (Alerts.OnCurrent)
            int whichBar=0;
      else      whichBar=1;            
      if (UpArrow[whichBar]!= EMPTY_VALUE) doAlert("HAma buy");   
      if (DnArrow[whichBar]!= EMPTY_VALUE) doAlert("HAma sell"); 
   }      
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workT3[][36];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workT3,0) != Bars)                ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (instanceNo+1)) ArrayResize(workT3Coeffs,instanceNo+1);

   if (workT3Coeffs[instanceNo][_period] != period)
   {
     workT3Coeffs[instanceNo][_period] = period;
        double a = hot;
            workT3Coeffs[instanceNo][_c1] = -a*a*a;
            workT3Coeffs[instanceNo][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[instanceNo][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[instanceNo][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[instanceNo][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[instanceNo][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = instanceNo*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[instanceNo][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[instanceNo][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[instanceNo][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[instanceNo][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[instanceNo][_c4]*workT3[r][2+buffer]);
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="";
   static datetime previousTime=0;
   string          message;
   
   if (previousAlert != doWhat || previousTime != Time[0])
   {
       previousAlert = doWhat;
       previousTime  = Time[0];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," HAMA T3 : ",doWhat);
          if (Alerts.Message) Alert(message);
          if (Alerts.Email)   SendMail(StringConcatenate(Symbol(),"HAMA T3 "),message);
          if (Alerts.Sound)   PlaySound("alert2.wav");
   }
}

